import CacheItem from './CacheItem';
import Mixin from './Mixin';
import Style from './Style';
declare type WebComponentStyle = string | Style;
declare type WebComponentStyles = WebComponentStyle | WebComponentStyle[];
declare abstract class WebComponent extends HTMLElement {
    readonly root: ShadowRoot;
    readonly class: typeof WebComponent;
    readonly global: import("nexie").Nexie;
    private debouncers;
    constructor();
    static tag: string;
    static html: string;
    static css: WebComponentStyles;
    static observed: Map<string, string>;
    static converters: Map<string, (value: string) => any>;
    static mode: ShadowRootInit;
    static mixins: (typeof Mixin)[];
    static get observedAttributes(): string[];
    connectedCallback(): void;
    adoptedCallback(): void;
    disconnectedCallback(): void;
    attributeChangedCallback(name: string, previous: string, current: string): void;
    get presenter(): string;
    set presenter(value: string);
    dispatch<T>(eventName: string, data: T): boolean;
    listen(eventName: string, listener: EventListenerOrEventListenerObject): this;
    unlisten(eventName: string, listener: EventListenerOrEventListenerObject): this;
    select(selector: string): Element[];
    static get cache(): CacheItem;
    static register(): void;
    destructor(): void;
}
export { WebComponentStyle };
export default WebComponent;
